{$F+}
unit ReadConf;

{ ----------------- Interface part --------------- }

Interface
uses Dos,WriteLog;

Type

      ReadyParams   = Record
                        N : LongInt;
                        S : String;
                      end;

      ReadyParamsArray = Array[0..15] of ReadyParams;

      CommandRun    = Procedure(Command    : Word;
                                ParamCnt   : Byte;
                                var Params : ReadyParamsArray;
                                var Result : Boolean);

      CharSetArray      = Set of Char;

{$I TYPE_COM.INC}

Const

      ErrorLongInt      : LongInt  = -37373737;

      DefaultSpaceChars : CharSetArray =
                          [#8,#10,#13,#32];

      DefaultEndChars   : CharSetArray =
                          [#8,#10,#13,#32,',',';','#'];

      DefaultCommChars  : CharSetArray =
                          [';','#'];

      DefaultSymbChars  : CharSetArray =
                          [#0..#255];

      DefaultLatSymb    : CharSetArray =
                          ['A'..'Z','a'..'z'];

      DefaultRusSymb    : CharSetArray =
                          [''..'',''..'',#224..''];

      DefaultUkrSymb    : CharSetArray =
                          [''..'',''..'',#224..'',#240..#249];

      LimitChars        : Array [0..3,0..1] of Char =
                          (('"','"'),(#39,#39),('{','}'),('[',']'));

Var

      SpaceChars        : CharSetArray;    { p (p᪠)    }
      CommChars         : CharSetArray;    {  砫 p  }
      EndChars          : CharSetArray;    { p⥫ p       }
      SymbChars         : CharSetArray;    {  p            }
      Global_Error      : Boolean;         { Hp 訡 ⥭   }
      ReadConfigFlag    : Boolean;         { True  - Config    }
                                           { False - Config   }
      ParamArray          : Array [0..31] of String;
      Parameters          : ReadyParamsArray;

      LinesScanned      : LongInt;
      CommandScanned    : LongInt;
      IncludedFile      : Word;
      ExternalCommandsRun : Array [0..255] of CommandRun;

Function  ReadToSpace    (var Buf:String)                 : String;
Function  CommandsFind   (
                S              : String;        { p       }
                NumToFind      : Byte;          { -   ᪠ }
                var Commands   : Array of CommandRec; { ᠭ     }
                var Parameters : ReadyParamsArray;    {  pp      }
                var ParamArray : Array of String{ Hpp. p.          }
                           )                              : LongInt;
Procedure CompileString  (S1   : String;
                          var ParamArray:Array of String;
                          var ParamCnt:Byte);
Procedure ReadConfigFile (Name   :String);

{ -------------- Implementation part ------------- }

Implementation

{Procedure ReadConfigFile (Name   :String);} {Forward;}
Procedure Com_Include(Command    : Word;   ParamCnt   : Byte;
                      var Params : ReadyParamsArray;
                      var Result : Boolean); Far;
  Begin
    ReadConfigFile(Params[1].S);
    Result:=True; { OK }
    Inc(CommandScanned);
    if Global_Error then Result:=False;
  end;

Procedure Com_Print(Command    : Word;   ParamCnt   : Byte;
                    var Params : ReadyParamsArray;
                    var Result : Boolean); Far;
  Begin
    Writeln(FormatString(Params[1].S));
    Result:=True; { OK }
    Inc(CommandScanned);
    if Global_Error then Result:=False;
  end;

Procedure Com_Rem(Command    : Word;   ParamCnt   : Byte;
                      var Params : ReadyParamsArray;
                      var Result : Boolean); Far;
  Begin
    Result:=True; { OK }
  end;

Const
      Com_Rem_Constant    : CommandRun = Com_Rem;
      InternalCommandsRun : Array [0..7] of CommandRun =
                            (Com_Include, Com_Print, Com_Rem, Com_Rem,
                             Com_Rem, Com_Rem, Com_Rem, Com_Rem);


Function ReadToSpace(var Buf:String):String;
Var
     S             : String;
     BL            : Byte absolute Buf;
     C             : Char;
     Idx,I,I2      : Word;
     Flag, K_Flag  : Boolean;
     Flag1,Flag2   : Boolean;
  Begin
    S:='';
    C:=Buf[1];
    Idx:=1;
    if C in SpaceChars
      then
      begin
        while C in SpaceChars do
        begin
          Inc(Idx);
          C:=Buf[Idx];
        end;
      end;
    Flag1:=False;
    for I:=0 to 3 do
      begin
      if C=LimitChars[I,0] then
        Begin
        I2:=I;
        I:=3;
        Flag1:=True;
        end;
      end;
      if Flag1
        then
          begin
          Inc(Idx);
          C:=Buf[Idx];
          While ((C<>LimitChars[I2,1]) and (Idx<=BL)) do
            begin
            S:=S+C;
            Inc(Idx);
            C:=Buf[Idx];
            end;
          Inc(Idx);
          end
        else
          Begin
          if C in CommChars
            then
              Begin
              ReadToSpace:='';
              Buf:='';
              exit;
              end
            else
              begin
              While (not(C in EndChars) and (Idx<=BL)) do
                begin
                S:=S+C;
                Inc(Idx);
                C:=Buf[Idx];
                end;
              end;
          end;
    ReadToSpace:=S;
    Buf:=Copy(Buf,Idx+1,BL-Idx{+1});
  end;

Procedure  CompileString(S1:String; var ParamArray:Array of String;
                         var ParamCnt:Byte);
Var
      I         : Byte;
      S2,S3     : String;
      S2L       : Byte Absolute S2;
  Begin
    For I:=0 to 15 do
      begin
        ParamArray[I]:='';
      end;
    I:=0;
    S2:=S1;
    While S2L>0 do
      begin
        S3:=ReadToSpace(S2);
        ParamArray[I]:=S3;
        Inc(I);
      end;
    if ParamArray[I]='' then Dec(I);
    ParamCnt:=I;
  end;

Function Char_Limiter(S:String;Min,Max:Byte):Boolean;
var       i:Byte;
          c:Char;
          SL:Byte absolute S;
          CB:Byte absolute C;
          F       : boolean;
  begin
    F:=True;
    for I:=1 to SL do
      begin
        C:=S[I];
        if ((CB<Min) or (CB>Max)) then
          begin
          F:=False;
          I:=SL;
          end;
      end;
  end;

Function CommandsFind(
                S              : String;      { p       }
                NumToFind      : Byte;        { -   ᪠ }
                var Commands   : Array of CommandRec; { ᠭ   }
                var Parameters : ReadyParamsArray;    {  pp    }
                var ParamArray : Array of String      { Hpp. p.  }
                ) : LongInt;
Var
         I,J,K,L,M,N,O,P        : LongInt;
         S1,S2,S3,S4,S5,S6      : String;
  begin
    S2:=S;
    For I:=0 to NumToFind do
      begin
        If S2=Commands[I].C
          then
          begin
            CommandsFind:=I;
            Parameters[0].S:=S2;
            Parameters[0].N:=0;
            For J:=1 to 15 do
              begin
                Parameters[J].S:='';
                Parameters[J].N:=ErrorLongInt;
              end;
            For J:=1 to Commands[I].N do
              begin
                S3:=ParamArray[J];
                K:=Commands[I].P[J];
                Parameters[J].S:=S3;
                with ParamType[K] do
                  begin
                  Case T of
                    1: begin
                         if Parameters[J].S[0]>Chr(B) then
                            Parameters[J].S[0]:=Chr(B);
                         if Char_Limiter(Parameters[J].S,L[0],L[1])
                            then Parameters[J].N:=0
                            else Parameters[J].N:=ErrorLongInt;
                       end;
                    2: begin
                         Case S3[1] of
                           '0'..'9','-','+' :
                                 begin
                                   M:=Str2Byte(S3,ErrorLongInt);
                                   If M<>ErrorLongInt then
                                     if ((M<L[0]) or (M>L[1])) then
                                       M:=ErrorLongInt;
                                 end;
                           '$' :
                                 begin
                                   M:=Hex2Byte(Copy(S3,2,8));
                                   If M<>ErrorLongInt then
                                     if ((M<L[0]) or (M>L[1])) then
                                       M:=ErrorLongInt;
                                 end;
                           else M:=ErrorLongInt;
                         end;
                         Parameters[J].N:=M;
                       end;
                    3: begin
                         O:=ErrorLongInt;
                         For M:=L[0] to L[1] do
                           begin
                             If UpCaseStr(S3)=CountedString[M] then
                               begin
                                 N:=M-L[0];
                                 O:=N mod B;
                                 M:=L[1];
                               end;
                           end;
                         Parameters[J].N:=O;
                       end;
                    end;
                  end;
              end;
            I:=NumToFind;
          end;
      end;  
  end;

Procedure ReadConfigFile(Name:String);
Var
    T                   : Text;
    S1,S2,S3,S4         : String;
    CommandCurrent      : CommandRun;
    ParamCnt            : Byte;
    I,J,K,M,N,O,P       : Byte;
    Result              : Boolean;
  begin
    Assign(T,Name);
    {$I-}
    Reset(T);
    {$I+}
    if IOResult<>0 then
      begin
        {WriteLogFile('ConfigFile '+UpCaseStr(Name)+' not found.',3);}
        Global_Error:=True;
        Exit;
      end;
    Inc(IncludedFile);
    ReadConfigFlag:=True;
    While (Not(EOF(T))and(ReadConfigFlag)) do
      begin
        Readln(T,S1);
        Inc(LinesScanned);
        CompileString(S1,ParamArray,ParamCnt);
        if ParamCnt>0 then
          begin
            S2:=UpCaseStr(ParamArray[0]);
               { Internal Commands }
            I:=CommandsFind(S2,7,DefaultIncludeCommand,Parameters,ParamArray);
            if I<8 then
              Begin
                CommandCurrent:=InternalCommandsRun[I];
                CommandCurrent(I,ParamCnt,Parameters,Result);
              end;
               { External Commands }
            I:=CommandsFind(S2,255,ExternalCommand,Parameters,ParamArray);
            if I<=255 then
              Begin
                CommandCurrent:=ExternalCommandsRun[I];
                CommandCurrent(I,ParamCnt,Parameters,Result);
              end;
          end;
      end;
    Close(T);
  end;

Procedure InitiateInternalVariables;
Var
    I,J,K   : Byte;
    P       : Pointer;
  begin
    SpaceChars := DefaultSpaceChars;
    CommChars  := DefaultCommChars;
    EndChars   := DefaultEndChars;
    SymbChars  := DefaultSymbChars;
    ReadConfigFlag:=True;
    IncludedFile:=0;
    LinesScanned:=0;
    CommandScanned:=0;
    For I:=0 to CountedStringNumber do
      CountedString[I]:=CountedStringInternal[I];
    For I:=0 to TypeInternalNumber do
      ParamType[I]:=ParamTypeInternal[I];
    For I:=CountedStringNumber+1 to 255 do
      CountedString[I]:='';
    For I:=TypeInternalNumber+1 to 255 do
      ParamType[I]:=ParamTypeInternal[0];
    For I:=0 to 255 do
      ExternalCommandsRun[I]:=Com_Rem;
    For I:=0 to 255 do
      ExternalCommand[I]:=DefaultIncludeCommand[2];
  end;

begin
  InitiateInternalVariables;
end.
{$F-}